Index: modules/calib3d/src/calibration.cpp
===================================================================
--- modules/calib3d/src/calibration.cpp	(revision 8133)
+++ modules/calib3d/src/calibration.cpp	(working copy)
@@ -166,13 +166,15 @@
     errNorm = cvNorm( err, 0, CV_L2 );
     if( errNorm > prevErrNorm )
     {
-        lambdaLg10++;
-        step();
-        _param = param;
-        cvZero( err );
-        _err = err;
-        state = CHECK_ERR;
-        return true;
+        if( ++lambdaLg10 <= 16 )
+        {
+            step();
+            _param = param;
+            cvZero( err );
+            _err = err;
+            state = CHECK_ERR;
+            return true;
+        }
     }
 
     lambdaLg10 = MAX(lambdaLg10-1, -16);
@@ -233,13 +235,15 @@
     assert( state == CHECK_ERR );
     if( errNorm > prevErrNorm )
     {
-        lambdaLg10++;
-        step();
-        _param = param;
-        errNorm = 0;
-        _errNorm = &errNorm;
-        state = CHECK_ERR;
-        return true;
+        if( ++lambdaLg10 <= 16 )
+        {
+            step();
+            _param = param;
+            errNorm = 0;
+            _errNorm = &errNorm;
+            state = CHECK_ERR;
+            return true;
+        }
     }
 
     lambdaLg10 = MAX(lambdaLg10-1, -16);
